#include <Adafruit_NeoPixel.h>
#include <AccelStepper.h>



#define NEOPIXEL_PIN D9      // Pin D2 en la Seeed XIAO RP2040
#define NUMPIXELS 12         // Número de NeoPixels en la tira
#define DELAYVAL 4000        // Tiempo (en milisegundos) para pausar entre grupos de LEDs
#define STEPPER_DIR_PIN D2   // Pin de dirección del motor paso a paso
#define STEPPER_STEP_PIN D1   // Pin de paso del motor paso a paso


Adafruit_NeoPixel pixels(NUMPIXELS, NEOPIXEL_PIN, NEO_GRB + NEO_KHZ800);
AccelStepper stepper(1, STEPPER_STEP_PIN, STEPPER_DIR_PIN);


void setup() {

  Serial.begin(9600);


  // Inicializar la tira de NeoPixels
  pixels.begin();
  pixels.setBrightness(200);
  pixels.show();


  // Inicializar el motor paso a paso

  stepper.setMaxSpeed(1000);

  stepper.setAcceleration(500);

}



void loop() {

  if(Serial.available() > 0){ //entra al if cuando esté recibiendo información

    char position = Serial.read(); //la variable de posición es lo que lea en el serial


    if(position == '0'){
      stepper.setSpeed(0);
      stepper.moveTo(0);
      stepper.runToPosition();
      pixels.clear();

  for (int i = 8; i < 12; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 255, 0)); // Color amarillo
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
}
     
    }

    else(position == '1'){
      stepper.setSpeed(0);
      stepper.moveTo(0);
      stepper.runToPosition();
      pixels.clear();
  for (int i = 4; i < 8; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 69, 0)); // Color naranja
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
    else(position == '2'){
      stepper.setSpeed(0);
      stepper.moveTo(0);
      stepper.runToPosition();
      pixels.clear();
    for (int i = 0; i < 4; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 0, 0)); // Color rojo
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
  else(position == '3'){
      stepper.setSpeed(500);
      stepper.moveTo(200);
      stepper.runToPosition();
      pixels.clear();
  for (int i = 8; i < 12; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 255, 0)); // Color amarillo
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
  else(position == '4'){
      stepper.setSpeed(500);
      stepper.moveTo(200);;
      stepper.runToPosition();
      pixels.clear();
  for (int i = 4; i < 8; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 69, 0)); // Color naranja
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
    else(position == '5'){
      stepper.setSpeed(500);
      stepper.moveTo(200);;
      stepper.runToPosition();
      pixels.clear();
    for (int i = 0; i < 4; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 0, 0)); // Color rojo
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
   else(position == '6'){
      stepper.setSpeed(500);
      stepper.moveTo(400);
      stepper.runToPosition();
      pixels.clear();
  for (int i = 8; i < 12; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 255, 0)); // Color amarillo
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
  else(position == '7'){
      stepper.setSpeed(500);
      stepper.moveTo(400);;
      stepper.runToPosition();
      pixels.clear();
  for (int i = 4; i < 8; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 69, 0)); // Color naranja
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
    else(position == '8'){
      stepper.setSpeed(500);
      stepper.moveTo(400);;
      stepper.runToPosition();
      pixels.clear();
    for (int i = 0; i < 4; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 0, 0)); // Color rojo
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
   else(position == '9'){
      stepper.setSpeed(500);
      stepper.moveTo(600);
      stepper.runToPosition();
      pixels.clear();
  for (int i = 8; i < 12; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 255, 0)); // Color amarillo
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
  else(position == '10'){
      stepper.setSpeed(500);
      stepper.moveTo(600);;
      stepper.runToPosition();
      pixels.clear();
  for (int i = 4; i < 8; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 69, 0)); // Color naranja
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }
    else(position == '11'){
      stepper.setSpeed(500);
      stepper.moveTo(600);;
      stepper.runToPosition();
      pixels.clear();
    for (int i = 0; i < 4; i++) {
    pixels.setPixelColor(i, pixels.Color(255, 0, 0)); // Color rojo
  }
  pixels.show();
  delay(DELAYVAL * 15); // Esperar 1 minuto (60,000 ms / 4,000 ms = 15)
  stepper.moveTo(0);
  stepper.runToPosition();
  pixels.clear();
  pixels.show();
    }

  }



}

